## teem 1.11.0~svn5112

=== debian/changelog ===
teem (1.11.0~svn5112-1) experimental; urgency=low

  * new upstream snapshot
  * updating mail address
  * bump standards version

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 20 Sep 2011 21:46:17 -0400

teem (1.11.0~svn5079-1) experimental; urgency=low

  * new upstream snapshot

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 30 Aug 2011 23:33:19 -0400

teem (1.11.0~svn5054-1) experimental; urgency=low

  * new upstream snapshot
  * debian/control: Bump compat level, fix Vcs-Browser field

 -- Dominique Belhachemi <domibel@debian.org>  Wed, 10 Aug 2011 17:26:47 -0400

teem (1.11.0~svn4425-2) experimental; urgency=low

  * move documentation build process to different target

 -- Dominique Belhachemi <domibel@debian.org>  Sun, 08 May 2011 00:18:53 -0400

teem (1.11.0~svn4425-1) experimental; urgency=low

  * New upstream snapshot
  * Switch to dpkg-source 3.0 (quilt) format
  * Remove static libraries
  * Added debug package
  * Removed DM-Upload-Allowed: yes
  * Bump Standards-Version: 3.9.1
  * Changed package name  libteem1-dev -> libteem-dev
  * Bump ABI version, libteem1 -> libteem2

 -- Dominique Belhachemi <domibel@debian.org>  Sun, 06 Mar 2011 17:21:11 -0500

teem (1.10.0.dfsg1-2) unstable; urgency=low

  [ Mathieu Malaterre ]
  * Add DEB_BUILD_OPTIONS options

  [ Dominique Belhachemi ]
  * added README.source
  * patch added to fix a bug that caused segfaults
  * debian/control: changed package description

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 18 Dec 2008 15:49:57 -0500

teem (1.10.0-1) unstable; urgency=low

  * Initial release  (Closes: #473044)

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 16 Dec 2008 14:11:30 -0500
